/*
	HC164 _16bit
	SETA43 28/08/2024
	seta43.duckdns.org
	seta43.blogspot.com
*/
 
#define ESPERA 4

#define PIN_CLK 13
#define DATA 2
#define CLEAR 3


char entrada[10];
boolean stringComplete = false;
int contador;

unsigned int valor;

void setup() 
{
	Serial.begin(9600); 
	pinMode(PIN_CLK, OUTPUT);
	pinMode(DATA, OUTPUT);
	pinMode(CLEAR, OUTPUT);
}


void loop() 
{
       
	while (Serial.available())
	  {
	    char inChar = (char)Serial.read();
	    entrada[contador] = inChar;
	    if (inChar == 13 || inChar == 10)
	    	{
		      stringComplete = true;
		      entrada[contador] = 0;
		    }
	    if(contador<9) contador++;
	  }

 	if (stringComplete)
	  {
		valor=atoi(entrada);
		mandarData(valor);
		contador = 0;
		stringComplete = false;
	  }

}


void mandarData(unsigned int dato)
{
 	Serial.print("mandarDATO->"); Serial.println(dato);
	 digitalWrite(CLEAR, LOW);
	 delay(ESPERA);
	 digitalWrite(CLEAR, HIGH);
	 for(char z=0;z<16;z++)
		{
		  if(dato & 32768) 
				digitalWrite(DATA, HIGH); 
			else 
				digitalWrite(DATA, LOW);
				
		  digitalWrite(PIN_CLK, LOW);
		  delay(ESPERA);
		  digitalWrite(PIN_CLK, HIGH);
		  delay(ESPERA);
	       dato<<=1;
		}
	 delay(ESPERA);	
	 digitalWrite(DATA, LOW);
	 digitalWrite(PIN_CLK, LOW);
}
